using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class Character : MonoBehaviour
{
	public enum CurrentRoom
	{
		LEFT,
		RIGHT
	}
	public static Vector2 leftPositionWife = new Vector2(-9.5f, 0f);
	public static Vector2 rightPositionWife = new Vector2(6, 0);
	public static Vector2 leftPositionHusband  = new Vector2(-7, 0);
	public static Vector2 rightPositionHusband  = new Vector2(8f, 0.5f);

	public Vector2 startingPosition;
	public CurrentRoom startingRoom;
	public CurrentRoom currentRoom;
    private int maxSatisfaction;
    private int maxRelax;

	public Sprite sprite;

	public int satisfaction;
	public int relax; 
	public float percentOfSatisfaction;
	public float percentOfRelax;

	public bool isActive;

	public GameObject satisfactionBar;
	public GameObject relaxBar;

    // Use this for initialization
    void Start()
    {
		startingPosition = this.transform.position;
		Debug.Log (startingPosition.ToString());
		startingRoom = currentRoom;
        maxSatisfaction = 100;
        satisfaction = 50;
		maxRelax = 100;
		relax = 50;

		isActive = false;

	}
	
    // Update is called once per frame
    void Update()
    {
        percentOfSatisfaction = (float)satisfaction / (float)maxSatisfaction;
        percentOfRelax = (float)relax / (float)maxRelax;
        satisfactionBar.GetComponent<Image>().fillAmount = percentOfSatisfaction;
        relaxBar.GetComponent<Image>().fillAmount = percentOfRelax;      
    }

    public void increaseSatisfaction(int value)
    {

        if (satisfaction + value <= maxSatisfaction)
        {
            satisfaction += value;
        }
        else
        {
            satisfaction += maxSatisfaction;
        }
    }

    public void decreaseSatisfaction(int value)
    {
		
        if (satisfaction - value > 0)
        {
            satisfaction -= value;
        }
        else
        {
            satisfaction = 0;
            OnEnd();
        }
    }

    public void increaseRelax(int value)
    {
		
        if (relax + value <= maxRelax)
        {
            relax += value;
        }
        else
        {
            relax += maxRelax;
        }
    }

    public void decreaseRelax(int value)
    {
		
        if (relax - value > 0)
        {
            relax -= value;
        }
        else
        {
            relax = 0;
            OnEnd();
        }
    }

    private void OnEnd()
    {

    }

}
