using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using System;

public class DayTimer : MonoBehaviour
{

		public static event Action DayFinished= null;

		public static string Result = "He goes mad!";


		private float dayTime;
		private float currentTimeCounter;

		private float accelerationTimeCounter;
		private bool acceleration;
		private bool titleAnimating;
		private bool titleAnimating2;
		private float animationTimeCounter;
		private float alpha;
		private float scaleFactor;
		private float currentTimeScale;

		private Character wife;
		private Character husband;

		private float framesPerDay;
		private float anglePerFrame;
		private float anglePerFrameBig;
		public GameObject smallPointer;
		public GameObject bigPointer;

		public GameObject dayTitle;
		public GameObject timeLeft;
		private int dayCounter;
		private int days;

		public GameObject toDoList;
		public GameObject arrowFast;

		public Text text;

		// Use this for initialization
		void Start ()
		{
				Cash.Own = 180;
				dayTime = 420;
				currentTimeCounter = 0;
				accelerationTimeCounter = 0f;
				animationTimeCounter = 0;
				titleAnimating = false;
				scaleFactor = 0;
				days = 11;
				dayCounter = days;
				currentTimeScale = 1;
				dayTitle = GameObject.Find ("day_title");
				dayTitle.SetActive (false);


				framesPerDay = dayTime / Time.fixedDeltaTime;
				anglePerFrame = 165 / framesPerDay;
				anglePerFrameBig = 2500 / framesPerDay;

				wife = GameObject.Find ("wife").GetComponent<Character> ();
				husband = GameObject.Find ("husband").GetComponent<Character> ();
		}
	
		// Update is called once per frame
		void FixedUpdate ()
		{

				currentTimeCounter += Time.fixedDeltaTime;
				text.GetComponent<Text> ().text = currentTimeCounter.ToString ();
				timeLeft.GetComponent<Text> ().text = "Time left: " + dayCounter.ToString () + " days. " + (7 - (int)(currentTimeCounter / 60)).ToString () + " hours.";
				tryAccelerate ();

				smallPointer.transform.Rotate (new Vector3 (0, 0, -anglePerFrame));
				bigPointer.transform.Rotate (new Vector3 (0, 0, -anglePerFrameBig));

				if (acceleration) {
						accelerationTimeCounter += Time.fixedDeltaTime;


						if (accelerationTimeCounter >= (5 * currentTimeScale)) {
								Time.timeScale = 1;
								acceleration = false;
								accelerationTimeCounter = 0;
								toDoList.SetActive (true);
								arrowFast.SetActive (false);
						}
				}

				if (currentTimeCounter >= dayTime) {
						DayEnd ();
				}

				fade ();


		}

		public void tryAccelerate2 ()
		{
				if (wife.gameObject.GetComponent<FastActivity> () != null
				    && husband.gameObject.GetComponent<FastActivity> () != null) {
						Time.timeScale = 120f;
				} else {
						Time.timeScale = 1f;
				}
		}

		public void tryAccelerate ()
		{
				if (wife.isActive && husband.isActive && (!acceleration)) {

						toDoList.SetActive (false);
						arrowFast.SetActive (true);
						Activity wifeActivity = wife.gameObject.GetComponent<Activity> ();
						Activity husbandActivity = husband.gameObject.GetComponent<Activity> ();
						float restTimeWife = wifeActivity.GetDuration () - wifeActivity.GetElapsedTime ();
						float restTimeHusband = husbandActivity.GetDuration () - husbandActivity.GetElapsedTime ();

						if ((restTimeWife) < (restTimeHusband)) {
								currentTimeScale = restTimeWife / 5f;
								Time.timeScale = currentTimeScale;
						} else {
								currentTimeScale = restTimeHusband / 5f;
								Time.timeScale = currentTimeScale;
						}
						acceleration = true;
				}
		
		}

		private void DayEnd ()
		{
				DayFinished ();
				dayTime = 420;
				Cash.Own += 50;
				currentTimeCounter = 0;
				accelerationTimeCounter = 0;
				titleAnimating = true;
				dayCounter -= 1;
				Time.timeScale = 1;
				acceleration = false;
				accelerationTimeCounter = 0;
				dayTitle.SetActive (true);
				arrowFast.SetActive (false);
				wife.isActive = false;
				wife.relax = Mathf.Max (wife.relax - 20, 0);
				wife.currentRoom = wife.startingRoom;
				wife.gameObject.transform.position = wife.startingPosition;
				husband.isActive = false;
				husband.relax = Mathf.Max (husband.relax - 20, 0);
				husband.currentRoom = husband.startingRoom;
				husband.gameObject.transform.position = husband.startingPosition;

				//Camera.main.transform.position = new Vector3 (wife.startingPosition.x, wife.startingPosition.y, Camera.main.transform.position.z);
				try { 
						Destroy (wife.GetComponent<Activity> ());
				} catch (Exception e) {
				}

				//Camera.main.transform.position = new Vector3 (wife.startingPosition.x, wife.startingPosition.y, Camera.main.transform.position.z);
				try { 
						Destroy (husband.GetComponent<Activity> ());
				} catch (Exception e) {
				}

				if (wife.satisfaction > 90) {
						Result = "Dorothy died due depression!";
						Application.LoadLevel ("GameOver");
				} else if (husband.satisfaction > 90) {
						Result = "Tobias died due depression";
						Application.LoadLevel ("GameOver");
				} else {
						Result = "You survived!";
				}

		}

		public void fade ()
		{
				if (titleAnimating) {
						animationTimeCounter += Time.fixedDeltaTime;

						dayTitle.SetActive (true);
						dayTitle.GetComponent<Image> ().color = new Color (1, 1, 1, alpha);
						alpha += 0.01f;
						scaleFactor += 0.0001f;
						dayTitle.transform.localScale += new Vector3 (scaleFactor, scaleFactor, scaleFactor);
						if (animationTimeCounter >= 2.5) {
								dayTitle.GetComponent<Image> ().color = new Color (1, 1, 1, 1);
								animationTimeCounter = 0;
								alpha = 0;
								titleAnimating = false;
								titleAnimating2 = true;
				
								//dayTitle.GetComponent<Text>().color = new Color(1,1,1,0);
						}
				}
		
				if (titleAnimating2) {
						scaleFactor -= 0.0001f;
						dayTitle.transform.localScale -= new Vector3 (scaleFactor, scaleFactor, scaleFactor);
						animationTimeCounter += Time.fixedDeltaTime;
						dayTitle.GetComponent<Image> ().color = new Color (1, 1, 1, 1 - alpha);
						alpha += 0.01f;
						if (animationTimeCounter >= 2.5) {
								alpha = 0;
								animationTimeCounter = 0;
								titleAnimating2 = false;
								dayTitle.GetComponent<Image> ().color = new Color (1, 1, 1, 0);
								dayTitle.SetActive (false);
						}
				}
	
		}
}


