﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class ActionPanelConf : MonoBehaviour
{
		#region Fields

		public static ActionPanelConf Instance;
		private QuestExecuter _ForWhom;
		public Color ColorBoth = Color.white;
		public Color ColorMale = Color.white;
		public Color ColorFemale = Color.white;
		public Image MaleImage;
		public Image FemaleImage;
		public GameObject QuestParent;

		public Text HeaderUI;

		public string HeaderBoth;
		public string HeaderMale;
		public string HeaderFemale;
		public QuestExecuter W;

		#endregion

		#region Properties

		public QuestExecuter ForWhom {
				get { return this._ForWhom; }
				set {
						List<Quest> lq = new List<Quest> ();
						int cnt = 0;
						for (int i = 0; i < QuestParent.transform.childCount; i++) {
								lq.Add (QuestParent.transform.GetChild (i).GetComponent<Quest> ());
						}
						this._ForWhom = value;
						if (value == QuestExecuter.BOTH) {
								this.GetComponent<Image> ().color = ColorBoth;
								this.HeaderUI.text = HeaderBoth;
								MaleImage.enabled = true;
								FemaleImage.enabled = true;
								for (int i = 0; i < lq.Count; i++) {
										if (lq [i].GetComponent<Quest> ().PossibleExecuter == QuestExecuter.BOTH) {
												lq [i].gameObject.SetActive (true);
										} else {
												lq [i].gameObject.SetActive (false);
												cnt++;
										}
								}
						} else if (value == QuestExecuter.MALE) {
								this.GetComponent<Image> ().color = ColorMale;
								this.HeaderUI.text = HeaderMale;
								FemaleImage.enabled = false;
								MaleImage.enabled = true;
								for (int i = 0; i < lq.Count; i++) {
										if (lq [i].GetComponent<Quest> ().PossibleExecuter == QuestExecuter.ANY
										    || lq [i].GetComponent<Quest> ().PossibleExecuter == QuestExecuter.MALE) {
												lq [i].gameObject.SetActive (true);
										} else {
												lq [i].gameObject.SetActive (false);
												cnt++;
										}
								}
						} else if (value == QuestExecuter.FEMALE) {
								this.GetComponent<Image> ().color = ColorFemale;
								this.HeaderUI.text = HeaderFemale;
								FemaleImage.enabled = true;
								MaleImage.enabled = false;
								for (int i = 0; i < lq.Count; i++) {
										if (lq [i].GetComponent<Quest> ().PossibleExecuter == QuestExecuter.ANY
										    || lq [i].GetComponent<Quest> ().PossibleExecuter == QuestExecuter.FEMALE) {
												lq [i].gameObject.SetActive (true);
										} else {
												lq [i].gameObject.SetActive (false);
												cnt++;
										}
								}
						}
						QuestParent.gameObject.GetComponent<RectTransform> ().sizeDelta = new Vector2 (206, 36 * (QuestParent.gameObject.transform.childCount - cnt));
				}
		}

		#endregion

		#region Mono Methods

		void Awake ()
		{
				Instance = this;
		}

		void Start ()
		{
				this.Hide ();
		}

		#endregion

		#region LogicMathods

		public void Hide ()
		{
				this.gameObject.SetActive (false);
		}

		public void Show ()
		{
				this.gameObject.SetActive (true);
		}

		#endregion
}
