﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class QuestInfoBox : MonoBehaviour
{
		#region Fields

		public static QuestInfoBox Instance;

		public Text QuestNameUIText;
		public Text QuestDescriptionUIText;

		public Text CashUI;
		public Text FemaleUI;
		public Text MaleUI;

		#endregion

		#region Mono Methods

		// Singleton lazy init;
		void Awake ()
		{
				Instance = this;
				this.Hide ();
		}

		#endregion

		#region Logic Methods

		public void ShowQuest (Quest quest)
		{
				this.gameObject.SetActive (true);
				this.QuestNameUIText.text = quest.Name;
				this.QuestDescriptionUIText.text = quest.InfoText;
				this.CashUI.text = quest.AddSubCash.ToString ();
				this.FemaleUI.text = quest.PropHerRage.ToString();
				this.MaleUI.text = quest.PropHisRage.ToString();
		}

		public void Hide ()
		{
				this.gameObject.SetActive (false);
		}

		#endregion
}
